Hooks:PostHook(BlackMarketTweakData, "_init_projectiles", "init_sippy", function(self)
	self.projectiles.damage_control.sounds.activate = "perkdeck_activate"
end)

Hooks:PreHook(PlayerManager, "attempt_ability", "sippy_add_stack", function(self, ability)
	if ability == "damage_control" then
		local local_peer_id = managers.network:session():local_peer():id()
		local has_no_grenades = self:get_grenade_amount(local_peer_id) == 0
		local is_downed = game_state_machine:verify_game_state(GameStateFilters.downed)
		local swan_song_active = managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier")
		if not self:player_unit() or has_no_grenades or is_downed or swan_song_active then
			return
		end
		self:set_drunk_effect(self._drunken_stacks and self._drunken_stacks + 1 or 1)
	end
end)

Hooks:PostHook(PlayerManager, "update", "sippy_stack_decay", function(self, t, dt)
	if self._drunken_stacks then
		if self._drunken_stacks > 10 then
			self._last_sip = self._last_sip or t
			if self._last_sip + (25 - math.clamp(math.floor(self._drunken_stacks / 3), 5, 18)) < t then
				self._last_sip = t
				self:set_drunk_effect(self._drunken_stacks - 1)
			end
			SoundDevice:set_rtpc("downed_state_progression", managers.environment_controller._current_concussion * 100 * 1.2)
		end
		if self._drunken_stacks > 15 and self:player_unit() and self._current_state == "standard"  then
			self:player_unit():camera():camera_unit():base():set_target_tilt(math.sin(80 * t) * math.min((self._drunken_stacks - 15) / 6, 5))
		end
	end
end)
if PlayerManager then
	function PlayerManager:set_drunk_effect(change)
		local prev_stack = self._drunken_stacks
		self._drunken_stacks = change
		local enviroment = managers.environment_controller
		if enviroment and self._drunken_stacks > 5 then
			enviroment._current_concussion = (self._drunken_stacks - 5) * 0.03
			enviroment._concussion_duration = 0	
			if self._last_sip then self._last_sip = nil end
			if self._drunken_stacks > 13 then
				SoundDevice:set_rtpc("downed_state_progression", enviroment._current_concussion * 100 * 1.2)
			else
				SoundDevice:set_rtpc("downed_state_progression", 0)
			end
			if self:player_unit() and prev_stack > 15 and self._drunken_stacks < 16 then
				self:player_unit():camera():camera_unit():base():set_target_tilt(0)
			end
			if self._drunken_stacks > 25 and not self._drunk_heart_loop_instance then
				self._drunk_heart_loop_instance = self:player_unit():sound():play("critical_state_heart_loop")
			elseif self._drunken_stacks < 26 and self._drunk_heart_loop_instance then
				self._drunk_heart_loop_instance:stop()
				self._drunk_heart_loop_instance = nil
			end
		end
	end
	function PlayerManager:reset_drunk_effect()
		self._drunken_stacks = 0
		local enviroment = managers.environment_controller
		if enviroment then
			enviroment._current_concussion = 0
			SoundDevice:set_rtpc("downed_state_progression", 0)
			if self._drunk_heart_loop_instance then
				self._drunk_heart_loop_instance:stop()
				self._drunk_heart_loop_instance = nil
			end
		end
	end
end

Hooks:PostHook(DoctorBagBase, "take", "sippy_get_sober", function(self, ...)
	local manager = managers.player
	if manager and manager._drunken_stacks and manager._drunken_stacks > 7 then
		manager:set_drunk_effect(math.max(math.floor(manager._drunken_stacks * 0.4), 8))
	end
end)

Hooks:PostHook(FirstAidKitBase, "take", "sippy_take_coffee", function(self, ...)
	local manager = managers.player
	if manager and manager._drunken_stacks and manager._drunken_stacks > 9 then
		manager:set_drunk_effect(math.max(manager._drunken_stacks - 6, 10))
	end
end)

Hooks:PostHook(IngameWaitingForRespawnState, "at_enter", "sippy_dead_af", function(self)
	local manager = managers.player
	if manager and manager._drunken_stacks then
		manager:reset_drunk_effect(0)
	end
end)